Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sun.media.imageio.stream
Class SegmentedImageInputStream

    java.lang.Object
      |
      +--javax.imageio.stream.ImageInputStreamImpl
            |
            +--com.sun.media.imageio.stream.SegmentedImageInputStream

All Implemented Interfaces:
  DataInput, ImageInputStream

public class SegmentedImageInputStream
extends ImageInputStreamImpl

A `SegmentedImageInputStream` provides a view of a subset of another `ImageInputStream` consiting of a series of segments with given starting positions in the source stream and lengths. The resulting stream behaves like an ordinary `ImageInputStream`.

For example, given a `ImageInputStream` containing data in a format consisting of a number of sub-streams stored in non-contiguous sectors indexed by a directory, it is possible to construct a set of `SegmentedImageInputStream`s, one for each sub-stream, that each provide a view of the sectors comprising a particular stream by providing the positions and lengths of the stream's sectors as indicated by the directory. The complex multi-stream structure of the original stream may be ignored by users of the `SegmentedImageInputStream`, who see a separate `ImageInputStream` for each sub-stream and do not need to understand the directory structure at all.

For further efficiency, a directory structure such as in the example described above need not be fully parsed in order to build a `SegmentedImageInputStream`. Instead, the `StreamSegmentMapper` interface allows the association between a desired region of the output and an input segment to be provided dynamically. This mapping might be computed by reading from a directory in piecemeal fashion in order to avoid consuming memory resources.

Field Summary

Fields inherited from class javax.imageio.stream.ImageInputStreamImpl
`bitOffset, byteOrder, flushedPos, streamPos`

Constructor Summary
`SegmentedImageInputStream(ImageInputStream stream, long[] segmentPositions, int[] segmentLengths)` Constructs a `SegmentedImageInputStream` given a `ImageInputStream` as input and a list of the starting positions and lengths of the segments of the source stream.
`SegmentedImageInputStream(ImageInputStream stream, long[] segmentPositions, int segmentLength, int totalLength)` Constructs a `SegmentedImageInputStream` given a `ImageInputStream` as input, a list of the starting positions of the segments of the source stream, the common length of each segment, and the total length of the segments.
`SegmentedImageInputStream(ImageInputStream stream, StreamSegmentMapper mapper)` Constructs a `SegmentedImageInputStream` given a `ImageInputStream` as input and an instance of `StreamSegmentMapper`.

Method Summary
`int` | `read()` Reads the next byte of data from the input stream.
`int` | `read(byte[] b, int off, int len)` Reads up to `len` bytes of data from the input stream into an array of bytes.

Methods inherited from class javax.imageio.stream.ImageInputStreamImpl
`checkClosed, close, finalize, flush, flushBefore, getBitOffset, getByteOrder, getFlushedPosition, getStreamPosition, isCached, isCachedFile, isCachedMemory, length, mark, read, readBit, readBits, readBoolean, readByte, readBytes, readChar, readDouble, readFloat, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readInt, readLine, readLong, readShort, readUnsignedByte, readUnsignedInt, readUnsignedShort, readUTF, reset, seek, setBitOffset, setByteOrder, skipBytes, skipBytes`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SegmentedImageInputStream

    public SegmentedImageInputStream(ImageInputStream stream,
                                     StreamSegmentMapper mapper)

  Constructs a `SegmentedImageInputStream` given a `ImageInputStream` as input and an instance of `StreamSegmentMapper`.

Parameters:
  `stream` - A source `ImageInputStream`
  `mapper` - An instance of the `StreamSegmentMapper` interface.

### SegmentedImageInputStream

    public SegmentedImageInputStream(ImageInputStream stream,
                                     long[] segmentPositions,
                                     int[] segmentLengths)

  Constructs a `SegmentedImageInputStream` given a `ImageInputStream` as input and a list of the starting positions and lengths of the segments of the source stream.

Parameters:
  `stream` - A source `ImageInputStream`
  `segmentPositions` - An array of `long`s giving the starting positions of the segments in the source stream.
  `segmentLengths` - An array of `int`s giving the lengths of segments in the source stream.

### SegmentedImageInputStream

    public SegmentedImageInputStream(ImageInputStream stream,
                                     long[] segmentPositions,
                                     int segmentLength,
                                     int totalLength)

  Constructs a `SegmentedImageInputStream` given a `ImageInputStream` as input, a list of the starting positions of the segments of the source stream, the common length of each segment, and the total length of the segments.

  This constructor is useful for selecting substreams of sector-oriented file formats in which each segment of the substream (except possibly the final segment) occupies a fixed-length sector.

Parameters:
  `stream` - A source `ImageInputStream`
  `segmentPositions` - An array of `long`s giving the starting positions of the segments in the source stream.
  `segmentLength` - The common length of each segment.
  `totalLength` - The total length of the source segments.

Method Detail

### read

    public int read()
             throws IOException

  Reads the next byte of data from the input stream. The value byte is returned as an `int` in the range `0` to `255`. If no byte is available because the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  Specified by:
    `read` in interface `ImageInputStream`
  Specified by:
    `read` in class `ImageInputStreamImpl`
  Returns:
    the next byte of data, or `-1` if the end of the stream is reached.
  Throws:
    `IOException` - if an I/O error occurs.

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws IOException

  Reads up to `len` bytes of data from the input stream into an array of bytes. An attempt is made to read as many as `len` bytes, but a smaller number may be read, possibly zero. The number of bytes actually read is returned as an integer.

  This method blocks until input data is available, end of stream is detected, or an exception is thrown.

  If `b` is `null`, a `NullPointerException` is thrown.

  If `off` is negative, or `len` is negative, or `off+len` is greater than the length of the array `b`, then an `IndexOutOfBoundsException` is thrown.

  If `len` is zero, then no bytes are read and `0` is returned; otherwise, there is an attempt to read at least one byte. If no byte is available because the stream is at end of stream, the value `-1` is returned; otherwise, at least one byte is read and stored into `b`.

  The first byte read is stored into element `b[off]`, the next one into `b[off+1]`, and so on. The number of bytes read is, at most, equal to `len`. Let k be the number of bytes actually read; these bytes will be stored in elements `b[off]` through `b[off+`k`-1]`, leaving elements `b[off+`k`]` through `b[off+len-1]` unaffected.

  In every case, elements `b[0]` through `b[off]` and elements `b[off+len]` through `b[b.length-1]` are unaffected.

  If the first byte cannot be read for any reason other than end of stream, then an `IOException` is thrown. In particular, an `IOException` is thrown if the input stream has been closed.

  Specified by:
    `read` in interface `ImageInputStream`
  Specified by:
    `read` in class `ImageInputStreamImpl`
  Parameters:
    `b` - the buffer into which the data is read.
    `off` - the start offset in array `b` at which the data is written.
    `len` - the maximum number of bytes to read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
  Throws:
    `IOException` - if an I/O error occurs.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD